; ----disable UAC prompt----
RequestExecutionLevel user

; ----Compressor----
SetCompressor /SOLID lzma

;---Definitions----
!define SNAME "NSIScons"

;----Includes----
!include "FileFunc.nsh"
!insertmacro "GetParameters"
!include "LogicLib.nsh"
!define StrReplaceV4 `!insertmacro StrReplaceV4`
!define StrContains '!insertmacro "_StrContainsConstructor"'

;-----Runtime switches----
CRCCheck off
AutoCloseWindow True
SilentInstall silent
WindowIcon off
XPSTYLE on 

;-----Set basic information-----
Name "${SNAME}"
Icon "${SNAME}.ico"
Caption "${SNAME}"
OutFile "..\${SNAME}.exe"

;-----Version Information------
LoadLanguageFile "${NSISDIR}\Contrib\Language files\English.nlf"

VIProductVersion "0.2.0.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "${SNAME}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" " rolandtoth 2014"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "${SNAME}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "0.2"

!macro StrReplaceV4 Var Replace With In
 Push ${Var1}
 Push ${Var2}
 Push `${Replace}`
 Push `${With}`
 Push `${In}`
 Call StrReplaceV4
 Pop `${Var}`
 Pop ${Var2}
 Pop ${Var1}
!macroend

!define Var0 $R0
!define Var1 $R1
!define Var2 $R2
!define Var3 $R3
!define Var4 $R4
!define Var5 $R5
!define Var6 $R6
!define Var7 $R7
!define Var8 $R8

!macro _StrContainsConstructor OUT NEEDLE HAYSTACK
  Push "${HAYSTACK}"
  Push "${NEEDLE}"
  Call StrContains
  Pop "${OUT}"
!macroend

Var params
Var commander_path
Var commandline
Var path

Section "Main"
	
	${GetParameters} $params
	
	ReadINIStr $commander_path "$EXEDIR\${SNAME}.ini" "${SNAME}" "CommanderPath"
	ReadINIStr $commandline "$EXEDIR\${SNAME}.ini" "${SNAME}" "Commandline"
	
	StrCmp $commander_path "" ErrorMsg CheckParams
	
	ErrorMsg:
		MessageBox MB_OK "Commander not found!$\nPlease check ${SNAME}.ini."
		Abort
	
	CheckParams:
	${Switch} "$params"
			
		${Case} "ADMINTOOLS"
			StrCpy $path $ADMINTOOLS
			${Break}

		${Case} "ADMINTOOLSALLUSERS"
			SetShellVarContext all
			StrCpy $path $ADMINTOOLS
			${Break}

		${Case} "APPDATA"
			StrCpy $path $APPDATA
			${Break}
				
		${Case} "APPDATAALLUSERS"
			SetShellVarContext all
			StrCpy $path $APPDATA
			${Break}
					
		${Case} "CDBURN_AREA"
			StrCpy $path $CDBURN_AREA
			${Break}
			
		${Case} "COMMONFILES"
			StrCpy $path $COMMONFILES
			${Break}
		
		${Case} "COMMONFILES32"
			StrCpy $path $COMMONFILES32
			${Break}
		
		${Case} "COMMONFILES64"
			StrCpy $path $COMMONFILES64
			${Break}
				
		${Case} "COOKIES"
			StrCpy $path $COOKIES
			${Break}
				
		${Case} "DESKTOP"
			StrCpy $path $DESKTOP
			${Break}
		
		${Case} "DESKTOPALLUSERS"
			SetShellVarContext all
			StrCpy $path $DESKTOP
			${Break}
		
		${Case} "DOCUMENTS"
			StrCpy $path $DOCUMENTS
			${Break}
				
		${Case} "DOCUMENTSALLUSERS"
			SetShellVarContext all
			StrCpy $path $DOCUMENTS
			${Break}
			
		${Case} "EXEDIR"
			StrCpy $path $EXEDIR
			${Break}
		
		${Case} "EXEPATH"
			StrCpy $path $EXEPATH
			${Break}
		
		${Case} "FAVORITES"
			StrCpy $path $FAVORITES
			${Break}
				
		${Case} "FAVORITESALLUSERS"
			SetShellVarContext all
			StrCpy $path $FAVORITES
			${Break}
		
		${Case} "FONTS"
			StrCpy $path $FONTS
			${Break}
				
		${Case} "HISTORY"
			StrCpy $path $HISTORY
			${Break}
				
		${Case} "INTERNET_CACHE"
			StrCpy $path $INTERNET_CACHE
			${Break}
					
		${Case} "LOCALAPPDATA"
			StrCpy $path $LOCALAPPDATA
			${Break}
						
		${Case} "MUSIC"
			StrCpy $path $MUSIC
			${Break}
		
		${Case} "MUSICALLUSERS"
			SetShellVarContext all
			StrCpy $path $MUSIC
			${Break}
		
		${Case} "NETHOOD"
			StrCpy $path $NETHOOD
			${Break}
			
		${Case} "NSISDIR"
		${Case} "{NSISDIR}"
			StrCpy $path ${NSISDIR}
			${Break}
					
		${Case} "PICTURES"
			StrCpy $path $PICTURES
			${Break}
		
		${Case} "PICTURESALLUSERS"
			SetShellVarContext all
			StrCpy $path $PICTURES
			${Break}
			
		${Case} "PRINTHOOD"
			StrCpy $path $PRINTHOOD
			${Break}
		
		${Case} "PROFILE"
			StrCpy $path $PROFILE
			${Break}
						
		${Case} "PROGRAMFILES"
			StrCpy $path $PROGRAMFILES
			${Break}
		
		${Case} "PROGRAMFILES32"
			StrCpy $path $PROGRAMFILES32
			${Break}
		
		${Case} "PROGRAMFILES64"
			StrCpy $path $PROGRAMFILES64
			${Break}
				
		${Case} "QUICKLAUNCH"
			StrCpy $path $QUICKLAUNCH
			${Break}
			
		${Case} "RECENT"
			StrCpy $path $RECENT
			${Break}
		
		${Case} "RESOURCES"
			StrCpy $path $RESOURCES
			${Break}
				
		${Case} "RESOURCES_LOCALIZED"
			StrCpy $path $RESOURCES_LOCALIZED
			${Break}
					
		${Case} "SENDTO"
			StrCpy $path $SENDTO
			${Break}
			
		${Case} "SMPROGRAMS"
			StrCpy $path $SMPROGRAMS
			${Break}
				
		${Case} "SMPROGRAMSALLUSERS"
			SetShellVarContext all
			StrCpy $path $SMPROGRAMS
			${Break}
				
		${Case} "SMSTARTUP"
			StrCpy $path $SMSTARTUP
			${Break}
				
		${Case} "SMSTARTUPALLUSERS"
			SetShellVarContext all
			StrCpy $path $SMSTARTUP
			${Break}
				
		${Case} "STARTMENU"
			StrCpy $path $STARTMENU
			${Break}
					
		${Case} "STARTMENUALLUSERS"
			SetShellVarContext all
			StrCpy $path $STARTMENU
			${Break}
		
		${Case} "SYSDIR"
			StrCpy $path $SYSDIR
			${Break}
		
		${Case} "TEMP"
			StrCpy $path $TEMP
			${Break}
			
		${Case} "TEMPLATES"
			StrCpy $path $TEMPLATES
			${Break}
				
		${Case} "TEMPLATESALLUSERS"
			SetShellVarContext all
			StrCpy $path $TEMPLATES
			${Break}
					
		${Case} "VIDEOS"
			StrCpy $path $VIDEOS
			${Break}
				
		${Case} "VIDEOSALLUSERS"
			SetShellVarContext all
			StrCpy $path $VIDEOS
			${Break}
						
		${Case} "WINDIR"
			StrCpy $path $WINDIR
			${Break}
				
		${Default}
			; try environment variables if no match
			StrCpy $path "%$params%"
			
	${EndSwitch}

	; add double quotes around path if it contains spaces
	${StrContains} $1 " " $path
	StrCmp $1 " " 0 +2
	StrCpy $path '"$path"'

	StrCpy $commandline '$commandline $path'
	
	; replace extra space after L and R parameters (Total Commander)
	${StrReplaceV4} $commandline "L= " "L=" $commandline
	${StrReplaceV4} $commandline "R= " "R=" $commandline
	
	IfFileExists "$commander_path" 0 CheckRelativePath
		Exec '"$commander_path" $commandline'
		Abort
	CheckRelativePath:
		IfFileExists "$EXEDIR\$commander_path" 0 ErrorMsg	
			Exec '"$EXEDIR\$commander_path" $commandline'
			Abort
	
SectionEnd



Function StrReplaceV4
Exch ${Var0} #in
Exch 1
Exch ${Var1} #with
Exch 2
Exch ${Var2} #replace
Push ${Var3}
Push ${Var4}
Push ${Var5}
Push ${Var6}
Push ${Var7}
Push ${Var8}
 
 StrCpy ${Var3} -1
 StrLen ${Var5} ${Var0}
 StrLen ${Var6} ${Var1}
 StrLen ${Var7} ${Var2}
 Loop:
  IntOp ${Var3} ${Var3} + 1
  StrCpy ${Var4} ${Var0} ${Var7} ${Var3}
  StrCmp ${Var3} ${Var5} End
  StrCmp ${Var4} ${Var2} 0 Loop
 
   StrCpy ${Var4} ${Var0} ${Var3}
   IntOp ${Var8} ${Var3} + ${Var7}
   StrCpy ${Var8} ${Var0} "" ${Var8}
   StrCpy ${Var0} ${Var4}${Var1}${Var8}
   IntOp ${Var3} ${Var3} + ${Var6}
   IntOp ${Var3} ${Var3} - 1
   IntOp ${Var5} ${Var5} - ${Var7}
   IntOp ${Var5} ${Var5} + ${Var6}
 
 Goto Loop
 End:
 
Pop ${Var8}
Pop ${Var7}
Pop ${Var6}
Pop ${Var5}
Pop ${Var4}
Pop ${Var3}
Pop ${Var2}
Pop ${Var1}
Exch ${Var0} #out
FunctionEnd


; StrContains
; This function does a case sensitive searches for an occurrence of a substring in a string. 
; It returns the substring if it is found. 
; Otherwise it returns null(""). 
; Written by kenglish_hi
; Adapted from StrReplace written by dandaman32
 
Var STR_HAYSTACK
Var STR_NEEDLE
Var STR_CONTAINS_VAR_1
Var STR_CONTAINS_VAR_2
Var STR_CONTAINS_VAR_3
Var STR_CONTAINS_VAR_4
Var STR_RETURN_VAR
 
Function StrContains
  Exch $STR_NEEDLE
  Exch 1
  Exch $STR_HAYSTACK
  ; Uncomment to debug
  ;MessageBox MB_OK 'STR_NEEDLE = $STR_NEEDLE STR_HAYSTACK = $STR_HAYSTACK '
    StrCpy $STR_RETURN_VAR ""
    StrCpy $STR_CONTAINS_VAR_1 -1
    StrLen $STR_CONTAINS_VAR_2 $STR_NEEDLE
    StrLen $STR_CONTAINS_VAR_4 $STR_HAYSTACK
    loop:
      IntOp $STR_CONTAINS_VAR_1 $STR_CONTAINS_VAR_1 + 1
      StrCpy $STR_CONTAINS_VAR_3 $STR_HAYSTACK $STR_CONTAINS_VAR_2 $STR_CONTAINS_VAR_1
      StrCmp $STR_CONTAINS_VAR_3 $STR_NEEDLE found
      StrCmp $STR_CONTAINS_VAR_1 $STR_CONTAINS_VAR_4 done
      Goto loop
    found:
      StrCpy $STR_RETURN_VAR $STR_NEEDLE
      Goto done
    done:
   Pop $STR_NEEDLE ;Prevent "invalid opcode" errors and keep the
   Exch $STR_RETURN_VAR  
FunctionEnd